/*
 * physics.c
 *
 * Moobox physics simulation
 *
 * (c) 2008 Thomas White <taw27@srcf.ucam.org>
 *
 * This file is part of OpenMooCow - accelerometer moobox simulator
 *
 * OpenMooCow is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * OpenMooCow is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenMooCow.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include  <stdlib.h>

#include "types.h"

PhysicsContext *physics_setup() {

	PhysicsContext *ctx;
	
	ctx = malloc(sizeof(PhysicsContext));
	if ( ctx == NULL ) return NULL;
	
	ctx->pos = 0;
	ctx->moo = 0;
	
	return ctx;

}

/* lval = acceleration upwards in cm/s/s */
void physics_update(PhysicsContext *ctx, int lval) {

	if ( lval > 1000 ) ctx->pos = 1000;
	if ( (lval < -1000) && (ctx->pos == 1000) ) {
		ctx->pos = 0;
		ctx->moo = 1;
	}

}

